$ ->
  bindEvents = ->
    $(document).on "mouseenter mouseleave", "[data-tooltip]", hover
    $("[data-tooltip] .tltp").on "click", preventClicksToParent

  preventClicksToParent = (event) ->
    event.preventDefault()
    event.stopPropagation()

  hover = (event) ->
    $hoveredElement = $(this)
    $tooltip = $hoveredElement.find(".tooltip")

    clearTimeout $tooltip.attr("data-tooltip-content-timeout")

    if event.type is "mouseenter"
      show $tooltip  if $tooltip.text() isnt ""
    else
      hide $tooltip

  position = ($tooltip) ->
    $tooltip.toggleClass "top", not elementVisibleBottom($tooltip)

  show = ($tooltip) ->
    $tooltip.attr "data-tooltip-content-timeout", setTimeout(->
      $tooltip.addClass "show"

      setTimeout (->
        $tooltip.addClass "fade"
        position $tooltip
      ), 15

    , 500)

  hide = ($tooltip) ->
    transitionDuration = 250
    $tooltip.removeClass "fade"

    setTimeout (->
      $tooltip.removeClass "show top"
    ), transitionDuration

  elementVisibleBottom = ($el) ->
    return  if $el.length < 1
    $el.offset().top + $el.height() <= $(window).scrollTop() + $(window).height()
  bindEvents()
